astro py:docs

- Index
- Modules

### Navigation

- next »
- « previous |
- Astropy v0.3 »
- FITS File handling (`astropy.io.fits`) »
- HDU Lists

# HDU Lists

## `HDUList`

class `astropy.io.fits.``HDUList`(hdus=, []file=None)

  Bases: `list`, `astropy.io.fits.verify._Verify`

  HDU list class. This is the top-level FITS object. When a FITS file is opened, a `HDUList` object is returned.

  `append`(hdu)

    Append a new HDU to the `HDUList`.

    Parameters:

    hdu : instance of _BaseHDU

    > HDU to add to the `HDUList`.

  `close`(output_verify='exception', verbose=False, closed=True)

    Close the associated FITS file and memmap object, if any.

    Parameters:

    output_verify : str

    > Output verification option. Must be one of `"fix"`, `"silentfix"`, `"ignore"`, `"warn"`, or `"exception"`. See Verification options for more info.

    verbose : bool

    > When `True`, print out verbose messages.

    closed : bool

    > When `True`, close the underlying file object.

  `fileinfo`(index)

    Returns a dictionary detailing information about the locations of the indexed HDU within any associated file. The values are only valid after a read or write of the associated file with no intervening changes to the `HDUList`.

    Parameters:

    index : int

    > Index of HDU for which info is to be returned.

    Returns:

    fileinfo : dict or None

    > The dictionary details information about the locations of the indexed HDU within an associated file. Returns `None` when the HDU is not associated with a file.

    > Dictionary contents:

    > Key | Value
    > --- | ---
    > file | File object associated with the HDU
    > filename | Name of associated file object
    > filemode | Mode in which the file was opened (readonly, update, append, denywrite, ostream)
    > resized | Flag that when `True` indicates that the data has been resized since the last read/write so the returned values may not be valid.
    > hdrLoc | Starting byte location of header in file
    > datLoc | Starting byte location of data block in file
    > datSpan | Data size including padding

  `filename`()

    Return the file name associated with the HDUList object if one exists. Otherwise returns None.

    Returns:

    filename : a string containing the file name associated with the

    > HDUList object if an association exists. Otherwise returns None.

  `flush`(*args, **kwargs)

    Force a write of the `HDUList` back to the file (for append and update modes only).

    Parameters:

    output_verify : str

    > Output verification option. Must be one of `"fix"`, `"silentfix"`, `"ignore"`, `"warn"`, or `"exception"`. See Verification options for more info.

    verbose : bool

    > When `True`, print verbose messages

  classmethod `fromfile`(fileobj, mode=None, memmap=False, save_backup=False, **kwargs)

    Creates an HDUList instance from a file-like object.

    The actual implementation of `fitsopen()`, and generally shouldn’t be used directly. Use `open()` instead (and see its documentation for details of the parameters accepted by this method).

  classmethod `fromstring`(data, **kwargs)

    Creates an HDUList instance from a string or other in-memory data buffer containing an entire FITS file. Similar to `HDUList.fromfile()`, but does not accept the mode or memmap arguments, as they are only relevant to reading from a file on disk.

    This is useful for interfacing with other libraries such as CFITSIO, and may also be useful for streaming applications.

    Parameters:

    data : str, buffer, memoryview, etc.

    > A string or other memory buffer containing an entire FITS file. It should be noted that if that memory is read-only (such as a Python string) the returned `HDUList`‘s data portions will also be read-only.

    kwargs : dict

    > Optional keyword arguments. See `astropy.io.fits.open()` for details.

    Returns:

    hdul : HDUList

    > An `HDUList` object representing the in-memory FITS file.

  `index_of`(key)

    Get the index of an HDU from the `HDUList`.

    Parameters:

    key : int, str or tuple of (string, int)

    > The key identifying the HDU. If `key` is a tuple, it is of the form (`key`, `ver`) where `ver` is an `EXTVER` value that must match the HDU being searched for.

    Returns:

    index : int

    > The index of the HDU in the `HDUList`.

  `info`(output=None)

    Summarize the info of the HDUs in this `HDUList`.

    Note that this function prints its results to the console—it does not return a value.

    Parameters:

    output : file, bool (optional)

    > A file-like object to write the output to. If `False`, does not output to a file and instead returns a list of tuples representing the HDU info. Writes to `sys.stdout` by default.

  `insert`(index, hdu)

    Insert an HDU into the `HDUList` at the given `index`.

    Parameters:

    index : int

    > Index before which to insert the new HDU.

    hdu : _BaseHDU instance

    > The HDU object to insert

  `readall`()

    Read data of all HDUs into memory.

  `update_extend`()

    Make sure that if the primary header needs the keyword `EXTEND` that it has it and it is correct.

  `writeto`(fileobj, output_verify='exception', clobber=False, checksum=False)

    Write the `HDUList` to a new file.

    Parameters:

    fileobj : file path, file object or file-like object

    > File to write to. If a file object, must be opened in a writeable mode.

    output_verify : str

    > Output verification option. Must be one of `"fix"`, `"silentfix"`, `"ignore"`, `"warn"`, or `"exception"`. See Verification options for more info.

    clobber : bool

    > When `True`, overwrite the output file if exists.

    checksum : bool

    > When `True` adds both `DATASUM` and `CHECKSUM` cards to the headers of all HDU’s written to the file.